class Face_Side_Colors

   def Face_Side_Colors.ents(ents)
     faces = []
     ents.each{|e|
       if e.is_a? Sketchup::Face
         faces.push e
       end
     }

     return faces

   end

####################################################################################################

   def Face_Side_Colors.f2b
     model     = Sketchup.active_model
     selection = model.selection
     if selection.empty?
       UI.messagebox("No selection")
     else
       model.start_operation("Front material to the back of selected faces")
       faces = Face_Side_Colors.ents(selection.to_a)
       selection.clear
       faces.each{|f|
         if f.material != nil and f.back_material == nil
           f.back_material = f.material
         elsif (f.material != f.back_material)
           selection.add f
         end
       }

       if selection.count > 0
         UI.messagebox("Not all faces could be fixed. Errors were selected.")
       end
     model.commit_operation
     end
   end

####################################################################################################

   def Face_Side_Colors.b2f
     model     = Sketchup.active_model
     selection = model.selection
     if selection.empty?
       UI.messagebox("No selection")
     else
       model.start_operation("Back material to the front of selected faces")
       faces = Face_Side_Colors.ents(selection.to_a)
       selection.clear
       faces.each{|f|
         if f.material == nil and f.back_material != nil
           f.material = f.back_material
         elsif (f.back_material != f.material)
           selection.add f
         end
       }

       if selection.count > 0
         UI.messagebox("Not all faces could be fixed. Errors were selected.")
       end
       model.commit_operation
     end
   end

####################################################################################################

   def Face_Side_Colors.ff2b
     model     = Sketchup.active_model
     selection = model.selection
     if selection.empty?
       UI.messagebox("No selection")
     else
       model.start_operation("Forced front material to the back of selected faces")
       faces = Face_Side_Colors.ents(selection.to_a)
       selection.clear
       faces.each{|f|
         if f.material != nil
           f.back_material = f.material
         end
       }
       model.commit_operation
     end
   end

####################################################################################################

   def Face_Side_Colors.fb2f
     model     = Sketchup.active_model
     selection = model.selection
     if selection.empty?
       UI.messagebox("No selection")
     else
       model.start_operation("Forced back material to the front of selected faces")
       faces = Face_Side_Colors.ents(selection.to_a)
       selection.clear
       faces.each{|f|
         if f.back_material != nil
           f.material = f.back_material
         end
       }
       model.commit_operation
     end
   end

####################################################################################################

   def Face_Side_Colors.sfsc
     model     = Sketchup.active_model
     selection = model.selection
     if selection.empty?
       UI.messagebox("No selection")
     else
       model.start_operation("Sync Face Side Materials")
       faces = Face_Side_Colors.ents(selection.to_a)
       selection.clear
       faces.each{|f|
         if f.material != nil and f.back_material == nil
           f.back_material = f.material
         end

         if f.back_material != nil and f.material == nil
           f.material = f.back_material
         end

         if (f.material != f.back_material)
           selection.add f
         end
       }

       if selection.count > 0
         UI.messagebox("Not all faces could be fixed. Errors were selected.")
       end
       model.commit_operation
     end
   end

####################################################################################################

   def Face_Side_Colors.rfsc
     model     = Sketchup.active_model
     selection = model.selection
     if selection.empty?
       UI.messagebox("No selection")
     else
       model.start_operation("Reverse face side materials")
       faces = Face_Side_Colors.ents(selection.to_a)
       selection.clear
       faces.each{|f|
       
           fm = f.material
           f.material = f.back_material
           f.back_material = fm
           f.reverse!
           
       }

       model.commit_operation
     end
   end

####################################################################################################

end

menu = UI.menu("Plugins").add_submenu("Face Side Colors")

menu.add_item("Front material to the back of selected faces")        {Face_Side_Colors.f2b}
menu.add_item("Back material to the front of selected faces")        {Face_Side_Colors.b2f}
menu.add_item("Forced front material to the back of selected faces") {Face_Side_Colors.ff2b}
menu.add_item("Forced back material to the front of selected faces") {Face_Side_Colors.fb2f}
menu.add_item("Sync Face Side Materials")                            {Face_Side_Colors.sfsc}
menu.add_item("Reverse face side materials")                         {Face_Side_Colors.rfsc}
